#property indicator_chart_window

extern bool bShowLabels = true;
extern color LabelColor = Chocolate;
extern int LabelSize = 12;
extern string LabelFont = "Arial";

extern string S0Starts = "00:00"; // tokyo open
extern string S0Ends   = "09:00"; // tokyo close
extern color S0Color = Blue;
extern string S0Label = "Tokyo";

extern string S1Starts = "08:00"; // london open
extern string S1Ends   = "12:00"; // london lunch
extern color S1Color = Pink;
extern string S1Label = "London A.M.";

extern string S2Starts = "12:00"; // london noon
extern string S2Ends   = "16:00"; // london close
extern color S2Color = DimGray;
extern string S2Label = "London P.M.";

extern string S3Starts = "14:00"; // NY open
extern string S3Ends   = "21:00"; // NY close
extern color S3Color = Yellow;
extern string S3Label = "New York";

string sn = "Session Boxes ";

int init()
{
   string n;

   n = sn + " S0";  
   ObjectCreate(n,OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet(n,OBJPROP_COLOR,S0Color);
   if (bShowLabels)
   {
      ObjectCreate(n+"label",OBJ_TEXT,0,0,0,0);
      ObjectSet(n+"label",OBJPROP_COLOR,LabelColor);
      ObjectSetText(n+"label",S0Label,LabelSize,LabelFont);
   }

   n = sn + " S1";  
   ObjectCreate(n,OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet(n,OBJPROP_COLOR,S1Color);
   if (bShowLabels)
   {
      ObjectCreate(n+"label",OBJ_TEXT,0,0,0,0);
      ObjectSet(n+"label",OBJPROP_COLOR,LabelColor);
      ObjectSetText(n+"label",S1Label,LabelSize,LabelFont);
   }

   n = sn + " S2";  
   ObjectCreate(n,OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet(n,OBJPROP_COLOR,S2Color);
   if (bShowLabels)
   {
      ObjectCreate(n+"label",OBJ_TEXT,0,0,0,0);
      ObjectSet(n+"label",OBJPROP_COLOR,LabelColor);
      ObjectSetText(n+"label",S2Label,LabelSize,LabelFont);
   }

   n = sn + " S3";  
   ObjectCreate(n,OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet(n,OBJPROP_COLOR,S3Color);
   if (bShowLabels)
   {
      ObjectCreate(n+"label",OBJ_TEXT,0,0,0,0);
      ObjectSet(n+"label",OBJPROP_COLOR,LabelColor);
      ObjectSetText(n+"label",S3Label,LabelSize,LabelFont);
   }
  
   return(0);
}

int deinit()
{
   string n = sn + " S0";
   ObjectDelete(n);
   if (bShowLabels) ObjectDelete(n+"label");
   n = sn + " S1";
   ObjectDelete(n);
   if (bShowLabels) ObjectDelete(n+"label");
   n = sn + " S2";
   ObjectDelete(n);
   if (bShowLabels) ObjectDelete(n+"label");
   n = sn + " S3";
   ObjectDelete(n);
   if (bShowLabels) ObjectDelete(n+"label");
   return(0);
}

int start()
{
   string n;
   
   int hbar = 0;
   int lbar = 0;
   
   int SessionBars = 0;
   
   int EndsAtBar = 0;
   int StartsAtBar = 0;


   // ---
   // 0
   // ---   
   EndsAtBar = iBarShift(NULL,0,StrToTime(S0Ends));
   StartsAtBar = iBarShift(NULL,0,StrToTime(S0Starts));
   SessionBars = StartsAtBar-EndsAtBar+1;
   
   n = sn + " S0";

   lbar = iLowest(NULL,0,MODE_LOW,SessionBars,EndsAtBar);
   hbar = iHighest(NULL,0,MODE_HIGH,SessionBars,EndsAtBar);
   
   ObjectSet(n,OBJPROP_TIME2,Time[EndsAtBar]);
   ObjectSet(n,OBJPROP_PRICE2,Low[lbar]);

   ObjectSet(n,OBJPROP_TIME1,Time[StartsAtBar]);
   ObjectSet(n,OBJPROP_PRICE1,High[hbar]);
   
   if (bShowLabels) 
   {
      n = n+"label";   
      ObjectSet(n,OBJPROP_TIME1,Time[StartsAtBar-5]);
      ObjectSet(n,OBJPROP_PRICE1,High[hbar]+0.0005);
   }
   
   // ---
   // 1
   // ---   
   EndsAtBar = iBarShift(NULL,0,StrToTime(S1Ends));
   StartsAtBar = iBarShift(NULL,0,StrToTime(S1Starts));
   SessionBars = StartsAtBar-EndsAtBar+1;
   
   n = sn + " S1";

   lbar = iLowest(NULL,0,MODE_LOW,SessionBars,EndsAtBar);
   hbar = iHighest(NULL,0,MODE_HIGH,SessionBars,EndsAtBar);
   
   ObjectSet(n,OBJPROP_TIME2,Time[EndsAtBar]);
   ObjectSet(n,OBJPROP_PRICE2,Low[lbar]);

   ObjectSet(n,OBJPROP_TIME1,Time[StartsAtBar]);
   ObjectSet(n,OBJPROP_PRICE1,High[hbar]);
   
   if (bShowLabels) 
   {
      n = n+"label";   
      ObjectSet(n,OBJPROP_TIME1,Time[StartsAtBar-5]);
      ObjectSet(n,OBJPROP_PRICE1,High[hbar]+0.0005);
   }
   
   // ---
   // 2
   // ---   
   EndsAtBar = iBarShift(NULL,0,StrToTime(S2Ends));
   StartsAtBar = iBarShift(NULL,0,StrToTime(S2Starts));
   SessionBars = StartsAtBar-EndsAtBar+1;
   
   n = sn + " S2";

   lbar = iLowest(NULL,0,MODE_LOW,SessionBars,EndsAtBar);
   hbar = iHighest(NULL,0,MODE_HIGH,SessionBars,EndsAtBar);
   
   ObjectSet(n,OBJPROP_TIME2,Time[EndsAtBar]);
   ObjectSet(n,OBJPROP_PRICE2,Low[lbar]);

   ObjectSet(n,OBJPROP_TIME1,Time[StartsAtBar]);
   ObjectSet(n,OBJPROP_PRICE1,High[hbar]);
   
   if (bShowLabels) 
   {
      n = n+"label";   
      ObjectSet(n,OBJPROP_TIME1,Time[StartsAtBar-5]);
      ObjectSet(n,OBJPROP_PRICE1,High[hbar]+0.0005);
   }
   
   // ---
   // 3
   // ---   
   EndsAtBar = iBarShift(NULL,0,StrToTime(S3Ends));
   StartsAtBar = iBarShift(NULL,0,StrToTime(S3Starts));
   SessionBars = StartsAtBar-EndsAtBar+1;
   
   n = sn + " S3";

   lbar = iLowest(NULL,0,MODE_LOW,SessionBars,EndsAtBar);
   hbar = iHighest(NULL,0,MODE_HIGH,SessionBars,EndsAtBar);
   
   ObjectSet(n,OBJPROP_TIME2,Time[EndsAtBar]);
   ObjectSet(n,OBJPROP_PRICE2,Low[lbar]);

   ObjectSet(n,OBJPROP_TIME1,Time[StartsAtBar]);
   ObjectSet(n,OBJPROP_PRICE1,High[hbar]);
   
   if (bShowLabels) 
   {
      n = n+"label";   
      ObjectSet(n,OBJPROP_TIME1,Time[StartsAtBar-5]);
      ObjectSet(n,OBJPROP_PRICE1,High[hbar]+0.0005);
   }

   return(0);
}

