//+------------------------------------------------------------------+
//| Magnified Market Price.mq4        ver1.4             by Habeeb   |
//+------------------------------------------------------------------+
//| _TRO_MODIFIED_VERSION                                  |
//| MODIFIED BY AVERY T. HORTON, JR. AKA THERUMPLEDONE@GMAIL.COM     |
//| I am NOT the ORIGINAL author 
//  and I am not claiming authorship of this indicator. 
//  All I did was modify it. I hope you find my modifications useful.|
//|                                                                  |
//+------------------------------------------------------------------+
#property indicator_chart_window

extern bool Show.Discount = false ;
extern bool Show.FibRetrace = True ;
extern bool Show.GPS = True;

extern int  myPeriod      = 0 ;
extern int  barsToCount   =1440 ;



  extern string FontType="Arial Bold" ; //"Comic Sans MS";
  extern string note5 = "Display the price in what corner?";
  extern string note6 = "Upper left=0; Upper right=1";
  extern string note7 = "Lower left=2; Lower right=3";
  extern int    WhatCorner=0;
  extern int    xAxis = 220;
  extern int    yAxis = 1;
  extern string note3 = "Font Size";
  extern int    FontSize=20;
  extern string note4 = "Font Type";
  
  extern string note1 = "Change font colors automatically? True = Yes";
  extern bool   Bid_Ask_Colors = True;
  extern string note2 = "Default Font Color";
  extern color  FontColor = Blue;
  extern color  FontColorUp = Lime;  
  extern color  FontColorDn = Red;   
  string        symbol , tChartPeriod , fibChartPeriod , gpsChartPeriod ;
  double        Old_Price, point;

int     digits, period, win, digits2, n, j, i, k;

double open, high, low, close, mid, range  ;  
double diff, space , pct, fibpct, clop, cllo, hicl;

int nHH, nLL; 

//+------------------------------------------------------------------+

int init()
  {
   symbol       =  Symbol() ; 
   digits       =  Digits ;
   point        =  Point ;

   if(myPeriod == 0) { period = Period() ; } else { period = myPeriod ; }    
   
   tChartPeriod   = TimeFrameToString(Period()) ;
   
   fibChartPeriod = TimeFrameToString(period) ;
    
    
   if(digits == 5 || digits == 3) { digits  = digits - 1 ; point = point * 10 ; } 
 
  
   return(0);
  }

//+------------------------------------------------------------------+

int deinit()
  {
  ObjectDelete("Market_Price_Label"); 
 
  return(0);
  }

//+------------------------------------------------------------------+

int start()
{

 close    = iClose( symbol, 0, 0) ;

 nHH      =  Highest(NULL,PERIOD_W1,MODE_HIGH,barsToCount,0); 
 nLL      =  Lowest(NULL,PERIOD_W1,MODE_LOW,barsToCount,0); 
 
 high     = iHigh( symbol, PERIOD_W1, nHH) ;
 low      = iLow( symbol, PERIOD_W1, nLL) ;

 range    = high - low ;

 diff     = high - close ;
 if(diff > 0) {pct = 100 * diff / high ; }
  
  
 diff     = iHigh( symbol,period , 0) - iLow( symbol,period , 0) ;
 if(diff > 0) { fibpct   = 100 * ( close - iLow( symbol,period , 0) ) / ( diff  ) ; } else { fibpct  = 0 ; }
  

  
   if (Bid_Ask_Colors == True)
   {
    if (Bid > Old_Price) FontColor = FontColorUp;
    if (Bid < Old_Price) FontColor = FontColorDn;
    Old_Price = Bid;
   }
   
 
 
   string Market_Price = tChartPeriod + " " +  symbol + " " + DoubleToStr(Bid, digits)   ;
   
   if( Show.FibRetrace ) 
   { 
      Market_Price = Market_Price + " " + DoubleToStr(fibpct, 2) + " f%-"+fibChartPeriod ; 
   }
   
   if( Show.Discount ) { Market_Price = Market_Price + " " + DoubleToStr(pct, 2) + " d%" ; }
   
   
   if( Show.GPS ) 
   { 
       open     = iOpen( symbol, period, 0) ;
       high     = iHigh( symbol, myPeriod, 0) ;
       low      = iLow( symbol, myPeriod, 0) ;
       
       clop     = (close - open) / point ;
       cllo     = (close - low) / point ;
       hicl     = (high - close) / point ;
       
      Market_Price = Market_Price + " " + fibChartPeriod 
                                  + " ClOp= " + DoubleToStr(clop, 0) 
                                  + " HiCl= " + DoubleToStr(hicl, 0) 
                                  + " ClLo= " + DoubleToStr(cllo, 0); 
   }



 
   ObjectCreate("Market_Price_Label", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("Market_Price_Label", Market_Price, FontSize, FontType, FontColor);
   ObjectSet("Market_Price_Label", OBJPROP_CORNER, WhatCorner);
   ObjectSet("Market_Price_Label", OBJPROP_XDISTANCE, xAxis);
   ObjectSet("Market_Price_Label", OBJPROP_YDISTANCE, yAxis);
  }

//+------------------------------------------------------------------+  

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}





//+------------------------------------------------------------------+    